#include "doorkeeper.hpp"
#include "doorkeeperConfig.h"
#include <iostream>
#include <fstream>
#include <memory>

int main() {
	typedef dk::Tyler<2> Tiler;
	typedef std::unique_ptr<std::ifstream> ifstreamptr;

	Tiler tiler(Tiler::coords(10, 6), Tiler::coords(64));

	const std::string map1(DATA_PATH"/test.map");
	const std::string map2(DATA_PATH"/test_2.map");

	std::cout << "Loading " << map1 << '\n';
	auto bottom_layer = &tiler.push_layer<int>(dk::Layer<int, 2>::streamer_type(ifstreamptr(new std::ifstream(map1))));
	std::cout << "Loading " << map2 << '\n';
	tiler.push_layer<char>(dk::Layer<char, 2>::streamer_type(ifstreamptr(new std::ifstream(map2))), dk::Vector<int, 2>(2));

	{
		auto ittest = bottom_layer->begin();
		for (int z = 0; z < 10; ++z) {
#if !defined(NDEBUG)
			std::cout << "At tile " << ittest.position() << " value " << *ittest << '\n';
#endif
			++ittest;
		}
	}

#if !defined(NDEBUG)
	std::cout << "Map size: " << tiler.map_size() << '\n';
#endif
	std::cout << "Total tiles: " << tiler.tiles_count() << '\n';
	return 0;
}
